# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import playerlib
import cmdlib
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/base/manager')
block  = es.import_addon('sam/base/pcontrol')

# * VARIABLES
nocliptag     = '#greenNOCLIP'
noclip_hudtag = 'NOCLIP'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### CREATE PLAYERS VAR ###
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_noclip_%s' % ply.steamid)
		var.set(0)

	cmdlib.registerSayCommand('!noclip', noclipCMD,'SAM')
	cmdlib.registerSayCommand('!sam_noclip', noclipCMD,'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### CREATE PLAYERS VAR ###
	for ply in playerlib.getPlayerList('#all'):
		if int(es.ServerVar('sam_noclip_%s' % ply.steamid)) == 1: unclip(ply)

	cmdlib.unregisterSayCommand('!noclip')
	cmdlib.unregisterSayCommand('!sam_noclip')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def noclipCMD(userid, args):
	if admins.isAdmin(es.getplayersteamid(userid)):
		if admins.checkAccess(es.getplayersteamid(userid), 'Noclip'):
			if args:
				try:
					target = playerlib.getPlayer(es.getuserid(args[0]))
					if admins.checkImmunity(es.getplayersteamid(userid), target.steamid): moduleAction(userid, target, 1)
				except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), noclip_hudtag)
			else: block.function(userid, 'Noclip', None)

# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def moduleAction(userid, target, menu=0):
	targetvar = es.ServerVar('sam_noclip_%s' % target.steamid)
	if int(targetvar) != 1:
		clip(target)
		func.tell('#all', func.lang_pcontrol('noclip_target_cliped', {'target':target.name}), nocliptag)
	else:
		unclip(target)
		func.tell('#all', func.lang_pcontrol('noclip_target_uncliped', {'target':target.name}), nocliptag)
	if menu == 0: block.function(userid, 'Noclip', None)

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def clip(target):
	targetvar = es.ServerVar('sam_noclip_%s' % target.steamid)
	targetvar.set(1)
	target.noclip(1)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def unclip(target):
	targetvar = es.ServerVar('sam_noclip_%s' % target.steamid)
	targetvar.set(0)
	target.noclip(0)

# ============================================================================================================================================================== #
# ========================================================================= EVENTS ============================================================================= #
# ============================================================================================================================================================== #
def player_activate(ev):
	var = es.ServerVar('sam_noclip_%s' % ev['userid'])
	var.set(0)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def round_end(ev):
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_noclip_%s' % ply.steamid)
		var.set(0)

# ============================================================================================================================================================== #